﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcApplication14;
using System.Collections;
using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
namespace MvcApplication14.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
      
       
        {
            ViewData["EmployeeID"] = EmployeeID;
            ViewData["ShipCountry"] = ShipCountry;
            return View();
        }

        public ActionResult BatchDataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            BatchDataResult result = new BatchDataResult();
            DataOperations obj = new DataOperations();
            if (dm.Skip != 0)
            {
                DataSource = obj.PerformSkip(DataSource, dm.Skip);
            }
            if (dm.Take != 0)
            {
                DataSource = obj.PerformTake(DataSource, dm.Take);
            }            
            result.result = DataSource;
            result.count = OrderRepository.GetAllRecords().Count();
            result.value = "Hai";
           
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public class BatchDataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public string value { get; set; } //custom property
        }

        public List<object> EmployeeID
        {
            get
            {
                var employeeID = OrderRepository.GetAllRecords().Select(s => s.EmployeeID).Distinct().ToList();
                var EmployeeID = new List<object>();
                foreach (var id in employeeID)
                {
                    EmployeeID.Add(new { value = id, text = id });
                }
                return EmployeeID;
            }
        }

        public List<object> ShipCountry
        {
            get
            {
                var shipCountry = OrderRepository.GetAllRecords().Select(s => s.ShipCountry).Distinct().ToList();
                var ShipCountry = new List<object>();
                foreach (var id in shipCountry)
                {
                    ShipCountry.Add(new { value = id, text = id });
                }
                return ShipCountry;
            }
        }  
        public ActionResult DetailUpdate(List<EditableOrder> changed)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            var data = OrderRepository.GetAllRecords();
           
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}